[ACM] hdu 4418 Time travel (高斯消元求期望)

Time travel




Problem Description

Agent K is one of the greatest agents in a secret organization called Men in Black. Once he needs to finish a mission by traveling through time with the Time machine. The Time machine can take agent K to some point (0 to n-1) on the timeline and when he gets to the end of the time line he will come back (For example, there are 4 time points, agent K will go in this way 0, 1, 2, 3, 2, 1, 0, 1, 2, 3, 2, 1, ...). But when agent K gets into the Time machine he finds it has broken, which make the Time machine can't stop (Damn it!). Fortunately, the time machine may get recovery and stop for a few minutes when agent K arrives at a time point, if the time point he just arrive is his destination, he'll go and finish his mission, or the Time machine will break again. The Time machine has probability Pk% to recover after passing k time points and k can be no more than M. We guarantee the sum of Pk is 100 (Sum(Pk) (1 <= k <= M)==100). Now we know agent K will appear at the point X(D is the direction of the Time machine: 0 represents going from the start of the timeline to the end, on the contrary 1 represents going from the end. If x is the start or the end point of the time line D will be -1. Agent K want to know the expectation of the amount of the time point he need to pass before he arrive at the point Y to finish his mission.
If finishing his mission is impossible output "Impossible !" (no quotes )instead.
 

Input
There is an integer T (T <= 20) indicating the cases you have to solve. The first line of each test case are five integers N, M, Y, X .D (0< N,M <= 100, 0 <=X ,Y < 100 ). The following M non-negative integers represent Pk in percentile.
 

Output
For each possible scenario, output a floating number with 2 digits after decimal point
If finishing his mission is impossible output one line "Impossible !" 
(no quotes )instead.
 

Sample Input
2 4 2 0 1 0 50 50 4 1 0 2 1 100
 

Sample Output
8.14 2.00
 

Source
解题思路:

转自:http://972169909-qq-com.iteye.com/blog/1689107

题意:一个人在数轴上来回走。以pi的概率走i步i∈[1, m]。给定n(数轴长度)。m。e(终点),s(起点),d(方向)。求从s走到e经过的点数期望
 
解析:设E[x]是人从x走到e经过点数的期望值,显然对于终点有:E[e] = 0
一般的:E[x] = sum((E[x+i]+i) * p[i])(i∈[1, m]) 
(走i步经过i个点,所以是E[x+i]+i)
 
建立模型:高斯消元每一个变量都是一个互不同样的独立的状态,因为人站在一个点,另一个状态是方向!比如人站在x点。有两种状态向前、向后,不能都当成一种状态建立方程,所以要把两个方向化为一个方向从而使状态不受方向的影响
实现:
n个点翻过去(除了头尾两个点~~~)变为2*(n-1)个点,比如:
6个点:012345  --->  0123454321
那么显然,从5開始向右走事实上就是相当于往回走
然后方向就由两个状态转化成一个状态的,然后每一个点就是仅仅有一种状态了,对每一个点建立方程高斯消元就可以

状态转移有E[x]=sum((E[x+i]+i)*p[i])

即 E[x]=sum(E[x+i]*p[i]) + sum(i*p[i])

即E[x]-E[x+1]*p[1]-E[x+2]*p[2]-.........-E[x+m]*p[m]=sum(i*p[i])

代码:

#include <iostream>
#include <string.h>
#include <stdio.h>
#include <algorithm>
#include <iomanip>
#include <queue>
#include <cmath>
using namespace std;
const double eps=1e-9;
double p[110];
bool vis[220];
int n,m,x,y,d;
double a[220][220];
int equ,var;//equ个方程,var个变量
double xi[220];//解集
bool free_x[220];

int sgn(double x)
{
    return (x>eps)-(x<-eps);
}

bool bfs()
{
    memset(vis,0,sizeof(vis));
    vis[x]=true;
    queue<int>q;
    q.push(x);
    while(!q.empty())
    {
        int first=q.front();
        q.pop();
        for(int i=1;i<=m;i++)
        {
            int temp=(first+i)%n;
            if(p[i]>=eps&&!vis[temp])
            {
                vis[temp]=true;
                q.push(temp);
            }
        }

    }
    if(vis[y]||vis[(n-y)%n])
        return true;
    return false;
}

void create()
{
    double sum=0;
    for(int i=1;i<=m;i++)
        sum+=p[i]*i;
    memset(a,0,sizeof(a));
    for(int i=0;i<n;i++)
    {
        a[i][i]=1;
        if(!vis[i])
            continue;
        if(i==y||i==(n-y)%n)
        {
            a[i][n]=0;
            continue;
        }
        a[i][n]=sum;
        for(int j=1;j<=m;++j)
        {
            a[i][(i+j)%n]-=p[j];//一定不能写成a[i][(i+j)%n]=-p[j];//由于同一个点可能到达两次或多次。系数要叠加,切记!

!! } } } int gauss() { equ=n,var=n; int i,j,k; int max_r; // 当前这列绝对值最大的行. int col; // 当前处理的列. double temp; int free_x_num; int free_index; // 转换为阶梯阵. col=0; // 当前处理的列. memset(free_x,true,sizeof(free_x)); for(k=0;k<equ&&col<var;k++,col++) { max_r=k; for(i=k+1;i<equ;i++) { if(sgn(fabs(a[i][col])-fabs(a[max_r][col]))>0) max_r=i; } if(max_r!=k) { // 与第k行交换. for(j=k;j<var+1;j++) swap(a[k][j],a[max_r][j]); } if(sgn(a[k][col])==0) { // 说明该col列第k行下面全是0了,则处理当前行的下一列. k--; continue; } for(i=k+1;i<equ;i++) { // 枚举要删去的行. if (sgn(a[i][col])!=0) { temp=a[i][col]/a[k][col]; for(j=col;j<var+1;j++) { a[i][j]=a[i][j]-a[k][j]*temp; } } } } for(i=k;i<equ;i++) { if (sgn(a[i][col])!=0) return 0; } if(k<var) { for(i=k-1;i>=0;i--) { free_x_num=0; for(j=0;j<var;j++) { if (sgn(a[i][j])!=0&&free_x[j]) free_x_num++,free_index=j; } if(free_x_num>1) continue; temp=a[i][var]; for(j=0;j<var;j++) { if(sgn(a[i][j])!=0&&j!=free_index) temp-=a[i][j]*xi[j]; } xi[free_index]=temp/a[i][free_index]; free_x[free_index]=0; } return var-k; } for (i=var-1;i>=0;i--) { temp=a[i][var]; for(j=i+1;j<var;j++) { if(sgn(a[i][j])!=0) temp-=a[i][j]*xi[j]; } xi[i]=temp/a[i][i]; } return 1; } int main() { int t;cin>>t; while(t--) { cin>>n>>m>>y>>x>>d; double temp; for(int i=1;i<=m;i++) { cin>>temp; p[i]=temp/100; } if(x==y) { cout<<"0.00"<<endl; continue; } n=(n-1)*2; if(d>0) x=(n-x)%n; if(!bfs()) { cout<<"Impossible !"<<endl; continue; } create(); if(!gauss()) cout<<"Impossible !"<<endl; else cout<<setiosflags(ios::fixed)<<setprecision(2)<<xi[x]<<endl; } return 0; }



原文地址:https://www.cnblogs.com/zfyouxi/p/5080717.html